int steps;

proctype collatz( int n )
{
  steps = 0;

  do
  :: ( n == 1 )     -> break;
  :: else steps = steps + 1;
          if
          :: ( n % 2 == 0 ) -> n = n / 2;
          :: else           -> n = 3 * n + 1;
          fi
  od
}

init
{
   int max_steps, max_n, n = 0;
   do
   :: (n == 101) -> break; 
   :: else ->
      n++;
      run collatz( n );
      if
      :: (max_steps < steps) -> max_steps = steps; max_n = n;
      :: else;
      fi
   od;

   printf ( "max: %d in %d steps\n", max_n, max_steps );
}
