#define M 7
#define N 15

chan buffer = [8] of { mtype, byte };

mtype { odd, even, end };

byte counter = 0;

proctype producer()
{
  do
  :: (counter < N) && (counter % 2 == 0) -> buffer!even,counter;
  :: (counter < N) && (counter % 2 == 1) -> buffer!odd,counter;
  :: (counter >= N)                      -> break;
  :: counter ++;
  od;

  buffer!end,-1;
  buffer!end,-1;
}

proctype consumer_odd()
{
  byte rec;

  do
  :: buffer?odd,rec ->     printf( "Printing %d\n", rec );
  :: buffer?end,rec ->     printf( "Ending at %d\n", rec ); break;
  od
}

proctype consumer_even()
{
  byte rec;

  do
  :: buffer?even,rec ->     printf( "Printing %d\n", rec );
  :: buffer?end,rec  ->     printf( "Ending at %d\n", rec ); break;
  od
}

init { run producer(); run consumer_odd(); run consumer_even() }
